module charon.common.binarytree;

import charon.common.tree;

export class BinaryTree(T) {
	protected:
		Tree!(T) root;
		
		void addNode(Tree!(T) current, Tree!(T) newNode)
			in {
			
			}
			out {
			
			}
			body {
				if (current is null)
					current = newNode;
				if (newNode.value < current.value)
				{
					if (current.leftSubtree is null)
						current.leftSubtree = newNode;
					else
						this.addNode(current.leftSubtree, newNode);
				} else {
					if (current.rightSubtree is null)
						current.rightSubtree = newNode;
					else
						this.addNode(current.rightSubtree,newNode);
				}
			}
		
	export:
		this()
			in {
			
			}
			out {
			
			}
			body {
				
			}
		
		this(T input)
			in {
			
			}
			out {
			
			}
			body {
				root = new Tree!(T)(input);
			}
			
		this(T[] input)
			in {
			
			}
			out {
			
			}
			body {
				foreach(T c; input)
				{
					Tree!(T) newNode = new Tree!(T)(c);
					this.addNode(root, newNode);
				}
			}
}