module charon.common.tree;

import charon.common.node;

export class Tree(T) : Node!(T) {
	protected:
		Tree!(T) m_left;
		Tree!(T) m_right;
	
	export:
		this ()
			in {
			
			}
			out {
			
			}
			body {
			
			}
			
		this (T c)
			in {
			
			}
			out {
			
			}
			body {
				m_value = c;
			}
	
		this(T left, T value, T right)
			in {
			
			}
			out {
			
			}
			body {
				m_left = new Tree!(T)(left);
				m_value = value;
				m_right = new Tree!(T)(right);
			}
			
		T left()
			in {
			
			}
			out (response) {
				assert(response == m_left);
			}
			body {
				return m_left.value;
			}
	
		T left(T t)
			in {
			
			}
			out {

			}
			body {
				return (m_left.value = t);
			}
		
		T right()
			in {
			
			}
			out (response) {
				assert(response == m_right);
			}
			body {
				return m_right.value;
			}
		
		T right(T t)
			in {
				
			}
			out {
				
			}
			body {
				return (m_right.value = t);
			}
			
			Tree!(T) rightSubtree()
				in {
				
				}
				out {
				
				}
				body {
					return m_right;
				}
				
			Tree!(T) rightSubtree(Tree!(T) t)
				in {
				
				}
				out {
				
				}
				body {
					return (m_right = t);
				}
				
			Tree!(T) leftSubtree()
				in {
				
				}
				out {
				
				}
				body {
					return m_left;
				}

			Tree!(T) leftSubtree(Tree!(T) t)
				in {
				
				}
				out {
				
				}
				body {
					return (m_left = t);
				}
}